## strongswan 0.1.1.4.gc50b8.osmo.epdg.202407182026

=== debian/changelog ===
strongswan (2:0.1.1.4.gc50b8.osmo.epdg.202407182026) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom nightly feed

 -- Osmocom OBS scripts <info@osmocom.org>  Thu, 18 Jul 2024 20:27:19 +0000

strongswan (2:0.1.1-osmo-epdg) unstable; urgency=medium

  [ Tobias Brunner ]
  * openssl: Load "legacy" provider in OpenSSL 3 for algorithms like MD4, DES etc.
  * openssl: Make fips_mode option work with OpenSSL 3
  * openssl: Log loaded providers

  [ Alexander Couzens ]
  * debian: remove kdf plugin file
  * debian: remove missing man pages
  * debian: configure: --disable-scepclient
  * debian: add build dependency to libosmocore-dev
  * debian: install osmo-epdg to extra-plugins
  * debian: add _copyright to not_installed
  * add a simplified git-version-gen script

  [ Harald Welte ]
  * README.md: Add a bit more overview informtion and link to homepage
  * use NLnet suggested wording to reference funding

 -- User <osmith@sysmocom.de>  Wed, 17 Jul 2024 11:10:25 +0200

strongswan (2:0.1.0-osmo-epdg) unstable; urgency=medium

  * First initial strongswan version for osmo-epdg

 -- Alexander Couzens <lynxis@fe80.eu>  Thu, 4 Jul 2024 20:00:00 +0100
